program out;
uses dos;
const
PSTBBit = 1;
PAFDBit = 2;
PINITBit = 4;
PSLCTBit = 8;
PContOff = 2;
PStatOff = 1;

{$I hexread}
{$I hprint}
procedure OutCode(pport,data : word);
var
wait : byte;
count : byte;
mask : word;
dummy : byte;
const

idle : byte = PINITBit;

begin
  port[pport+PContOff] := idle;
  mask := $8000;
  { shift in lock/idle/sel code:  data = PAFD, clock = PSTB }
  { PSTB high and low times must be > 2 USEC because of digital filter }
  { in ISIO EPLD }
  for count := 1 to 16 do
  begin
    if (mask and data) <> 0 then dummy := (PAFDBit or idle) else dummy := idle;
    port[pport+PContOff] := dummy; { output data bit on PAFD }
    for wait := 1 to 10 do;
    dummy := dummy or PSTBBit;
    port[pport+PContOff] := dummy; { set strobe bit }
    for wait := 1 to 10 do;
    port[pport+PContOff] := idle;  { clear strobe bit }
    for wait := 1 to 10 do;
    mask := (mask shr 1);
  end;
  { Once lock or idle code is shifted in, }
  { latch in by setting pinit low while pslctin is high (pslctin is inverted)}
  { dont assert /pinit with pslctin low or you will reset the ISIO}
  for wait := 1 to 10 do;
  port[pport+PContOff] := 0; { assert /pinit with pslctin high }
  for wait := 1 to 10 do;
  port[pport+PContOff] := Idle;  { remove /pinit }
end;

function ReadIns(pport : word): byte;
var
dummy : byte;
const

idle : byte = PINITBit;

begin
  port[pport+PContOff] := idle;
  dummy := port[pport+PStatOff]; {read in 4 lsbs (in 4 msbs)}
  dummy := dummy shr 4;
  port[pport+PContOff] := idle or PSLCTBit;
  dummy := dummy or (port[pport+PStatOff] and $F0); {read in 4 msbs (in 4 msbs)}
  ReadIns := dummy;
end;

procedure ScanParms;
var
theport : word;
thedata : word;
didit : boolean;
begin
  didit := false;
  if HexWordRead(Paramstr(1),theport) then
  begin
    if HexWordRead(Paramstr(2),word(thedata)) then
    begin
      OutCode(thePort,thedata);
      write('Input status = ');
      HexPrint(ReadIns(theport),2);
      writeln;
      didit := true;
      if ParamCount = 3 then
      begin
        if HexWordRead(Paramstr(3),word(thedata)) then
        begin
          port[theport] := thedata;
        end;
      end;
    end;
  end;
  if not didit then writeln('Nothing done!');
end;

procedure Usage;
begin
  writeln;
  writeln(' ISIO - Enables/Disables/Accesses ISIO card');
  writeln;
  writeln(' USAGE - ISIO port code [data] ');
  writeln(' Where port is a 16 bit hex port address');
  writeln(' and code is an 16 bit hex value');
  writeln(' and data is optional 4 bit output data ');
  writeln('(standard unlock code is EABX / idle is DEDX)');
  writeln('(where X is card number set by ISIO jumpers)');
  writeln;
  halt(2);
end;

begin
  if ParamCount < 2 then Usage;
  writeln;
  ScanParms;
  halt(0);
end.
